routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\MessageController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () { return view('welcome'); });

Route::get('/dashboard', [UserController::class,'get_all_users'] )->middleware(['auth'])->name('dashboard');

Route::middleware('auth')->group(function() {
    Route::post('send-message', [MessageController::class, 'sendMsg'])->name('messages.send');
    Route::get('load-messages', [MessageController::class, 'loadMsgs'])->name('messages.load');
    Route::get('check-messages', [MessageController::class, 'checkMsgs'])->name('messages.check');
    Route::post('delete-message', [MessageController::class, 'deleteMsg'])->name('messages.delete');
    Route::post('mark-as-read-message', [MessageController::class, 'markAsRead'])->name('messages.seen');
});

require __DIR__.'/auth.php';

app/Models/Message.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Message extends Model
{
    use HasFactory; 
    use SoftDeletes;

    //protected $fillable = ['sender_id','message'];

    public function user(){
        return $this->belongsTo(User::class);
    }
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ]; 

    public function messages(){
        return $this->hasMany(Message::class, 'sender_id');
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/MessageController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Message;
use DB;
use Auth;
use App\Events\SendMessage;

class MessageController extends Controller
{
    public function sendMsg(Request $request){
        $user_id = Auth::id();
        $data = $request->all();
        $message = new Message();
        $message->sender_id = $user_id;
        $message->receiver_id  = $request->receiver_id;
        $message->text = $request->text;
        $message->save();
        broadcast(new SendMessage(Auth::user(), $message))->toOthers();
        return $message;
    }

    public function loadMsgs(Request $request){
        $user_id = Auth::id();
        $messages = Message::Where(function ($query) use($request, $user_id) {
            $query->where('sender_id', $request->sender_id)->where('receiver_id', $user_id);
        })
        ->orWhere(function ($query) use($request, $user_id) {
            $query->where('sender_id', $user_id)->where('receiver_id', $request->sender_id);
        })
        ->orderBy('id')
        ->get();
        
        return $messages;
    }

    public function markAsRead(Request $request){
        Message::Where(function ($query) use($request) {
            $query->where('sender_id', $request->sender_id)->where('receiver_id', Auth::id());
        })->update(['status' =>'seen']);
    }

    public function checkMsgs(Request $request){
        $user_id = Auth::id();
        $messages = Message::select(DB::raw('count(id) as message_count'), 'sender_id')
            ->where('status', 'new')
            ->where('receiver_id', $user_id)
            ->groupBy('sender_id')
            ->get();
        $delMessages = Message::select(DB::raw('count(id) as message_count'), 'sender_id')
            ->withTrashed()
            ->where('deleted_at', '>=', date('Y-m-d H:i:s', strtotime('-5 seconds')))
            ->where('receiver_id', $user_id)
            ->groupBy('sender_id')
            ->get();
        return ['new_messages' => $messages, 'deleted_messages' => $delMessages];
    }

    public function deleteMsg(Request $request){
        $messages = Message::where('id', $request->message_id)->delete();
        return 'true';
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\User;
use Auth;

class UserController extends Controller
{

    public function get_all_users(Request $request){
        $cUser = Auth::user();
        $cUserId = $cUser->id;
        $users = User::where('id', '!=', $cUserId)->withCount(['messages' => function($q) use ($cUserId) {
            $q->where('receiver_id',  $cUserId)
              ->where('status', 'new');
        }])->get();
        return view('dashboard', compact('users', 'cUser'));
    }
    
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

app/View/Components/GuestLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class GuestLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.guest');
    }
}

resources/views/dashboard.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Dashboard') }}
        </h2>
    </x-slot>

    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="p-6 bg-white border-b border-gray-200">
                    <!-- This is an example component -->
                    <div class="grid grid-cols-3 min-w-full border rounded" style="min-height: 80vh;">
                            <div class="col-span-1 bg-white border-r border-gray-300">
                                <div class="my-3 mx-3 ">
                                    <div class="relative text-gray-600 focus-within:text-gray-400">
                                        <span class="absolute inset-y-0 left-0 flex items-center pl-2">
                                            <svg fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" viewBox="0 0 24 24" class="w-6 h-6 text-gray-500"><path d="M21 21l-6-6m2-5a7 7 0 11-14 0 7 7 0 0114 0z"></path></svg>
                                        </span>
                                        <input aria-placeholder="Serach member" placeholder="Serach member"
                                        class="py-2 pl-10 block w-full rounded bg-gray-100 outline-none focus:text-gray-700" type="search" name="search" required autocomplete="search" />
                                    </div>
                                </div>

                                <ul class="overflow-auto">
                                    <h2 class="ml-2 mb-2 text-gray-600 text-lg my-2">Chats</h2>
                                    <li>
                                    @foreach ($users as $key => $user) 

                                        <!-- bg-gray-100 -->
                                        <a class="hover:bg-gray-100 border-b border-gray-300 px-3 py-2 cursor-pointer flex items-center text-sm focus:outline-none focus:border-gray-300 transition duration-150 ease-in-out user-item" data-id="{{ $user->id }}" data-name="{{ $user->name }}">
                                            <img class="h-10 w-10 rounded-full object-cover" src="{{ url('img/user-icon.jpg')}}" alt="username" />
                                            <div class="w-full pb-4">
                                                <div class="flex justify-between">
                                                    <span class="block ml-2 font-semibold text-base text-gray-600">{{ $user->name }}</span>
                                                    <div id="message-count-{{ $user->id }}">
                                                    @if($user->messages_count != 0)
                                                    <span class="block ml-2 text-sm text-gray-600 message-count border rounded">{{ $user->messages_count }}</span>
                                                    @endif
                                                    </div>
                                                </div>
                                                <!-- <span class="block ml-2 text-sm text-gray-600">I am fine</span> -->
                                            </div>
                                        </a>

                                    @endforeach

                                    </li>
                                </ul>
                            </div>
                            <div class="col-span-2 bg-white">
                                <div class="w-full">
                                    <div class="flex items-center border-b border-gray-300 pl-3 py-3" style="display: none;" id="receiver_user_details">
                                        <img class="h-10 w-10 rounded-full object-cover" src="{{ url('img/user-icon.jpg' )}}" alt="username" />
                                        <span class="block ml-2 font-bold text-base text-gray-600" id="receiver_user_name"></span>
                                        <!-- <span class="connected text-green-500 ml-2" >
                                            <svg width="6" height="6">
                                                <circle cx="3" cy="3" r="3" fill="currentColor"></circle>
                                            </svg>
                                        </span> -->
                                    </div>
                                    <div id="chat" class="w-full overflow-y-auto p-10 relative" style="height: 700px;" ref="toolbarChat">
                                        <ul>
                                            <li id="chat-area" class="clearfix2">
                                            <div class="w-full flex msgBox"><div class="bg-gray-100 rounded px-5 py-2 my-2 text-gray-700 relative" style="max-width: 300px;"><span class="block">Select user for chat</span><span class="block text-xs text-right"></span></div><span class="block text-xs text-right ml-2 mt-2 cursor-pointer delMsg" data-msgid=""></span></div>
                                            </li>
                                        </ul>
                                    </div>
                                    <form id="messageForm" style="display: none;">
                                    <div class="w-full py-3 px-3 flex items-center justify-between border-t border-gray-300">
                                        
                                        <input aria-placeholder="Enter the message" placeholder="Enter the message" class="py-2 mx-3 pl-5 block w-full rounded-full bg-gray-100 outline-none focus:text-gray-700" type="text" name="message" id="message" required/>
                                        <input type="hidden" id="selected-user-id">
                                        <button class="outline-none focus:outline-none" type="submit" id="sendMessage">
                                            <svg class="text-gray-400 h-7 w-7 origin-center transform rotate-90" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor">
                                                <path d="M10.894 2.553a1 1 0 00-1.788 0l-7 14a1 1 0 001.169 1.409l5-1.429A1 1 0 009 15.571V11a1 1 0 112 0v4.571a1 1 0 00.725.962l5 1.428a1 1 0 001.17-1.408l-7-14z" />
                                            </svg>
                                        </button>
                                        
                                    </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">

        <title>{{ config('app.name', 'Laravel') }}</title>

        <!-- Fonts -->
        <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

        <!-- Scripts -->
        <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
        <script src="{{ url('js/chat.js')}}"></script>
        <link href="{{ mix('css/app.css') }}" rel="stylesheet">
        <script src="{{ mix('js/app.js') }}"></script>
    </head>
    <body class="font-sans antialiased">
        <div class="min-h-screen bg-gray-100">
            @include('layouts.navigation')

            <!-- Page Heading -->
            <header class="bg-white shadow">
                <div class="max-w-7xl mx-auto py-6 px-4 sm:px-6 lg:px-8">
                    {{ $header }}
                </div>
            </header>

            <!-- Page Content -->
            <main>
                {{ $slot }}
            </main>
        </div>
    </body>
</html>

resources/views/layouts/guest.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">

        <title>{{ config('app.name', 'Laravel') }}</title>

        <!-- Fonts -->
        <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">
        <link href="{{ mix('css/app.css') }}" rel="stylesheet">
        <script src="{{ mix('js/app.js') }}"></script>
    </head>
    <body>
        <div class="font-sans text-gray-900 antialiased">
            {{ $slot }}
        </div>
    </body>
</html>

resources/views/layouts/navigation.blade.php
<nav x-data="{ open: false }" class="bg-white border-b border-gray-100">
    <!-- Primary Navigation Menu -->
    <div class="max-w-7xl mx-auto px-4 sm:px-6 lg:px-8">
        <div class="flex justify-between h-16">
            <div class="flex">
                <!-- Logo -->
                <div class="shrink-0 flex items-center">
                    <a href="{{ route('dashboard') }}">
                        <x-application-logo class="block h-10 w-auto fill-current text-gray-600" />
                    </a>
                </div>

                <!-- Navigation Links -->
                <div class="hidden space-x-8 sm:-my-px sm:ml-10 sm:flex">
                    <x-nav-link :href="route('dashboard')" :active="request()->routeIs('dashboard')">
                        {{ __('Dashboard') }}
                    </x-nav-link>
                </div>
            </div>

            <!-- Settings Dropdown -->
            <div class="hidden sm:flex sm:items-center sm:ml-6">
                <x-dropdown align="right" width="48">
                    <x-slot name="trigger">
                        <button class="flex items-center text-sm font-medium text-gray-500 hover:text-gray-700 hover:border-gray-300 focus:outline-none focus:text-gray-700 focus:border-gray-300 transition duration-150 ease-in-out">
                            <div>{{ Auth::user()->name }}</div>

                            <div class="ml-1">
                                <svg class="fill-current h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20">
                                    <path fill-rule="evenodd" d="M5.293 7.293a1 1 0 011.414 0L10 10.586l3.293-3.293a1 1 0 111.414 1.414l-4 4a1 1 0 01-1.414 0l-4-4a1 1 0 010-1.414z" clip-rule="evenodd" />
                                </svg>
                            </div>
                        </button>
                    </x-slot>

                    <x-slot name="content">
                        <!-- Authentication -->
                        <form method="POST" action="{{ route('logout') }}">
                            @csrf

                            <x-dropdown-link :href="route('logout')"
                                    onclick="event.preventDefault();
                                                this.closest('form').submit();">
                                {{ __('Log Out') }}
                            </x-dropdown-link>
                        </form>
                    </x-slot>
                </x-dropdown>
            </div>

            <!-- Hamburger -->
            <div class="-mr-2 flex items-center sm:hidden">
                <button @click="open = ! open" class="inline-flex items-center justify-center p-2 rounded-md text-gray-400 hover:text-gray-500 hover:bg-gray-100 focus:outline-none focus:bg-gray-100 focus:text-gray-500 transition duration-150 ease-in-out">
                    <svg class="h-6 w-6" stroke="currentColor" fill="none" viewBox="0 0 24 24">
                        <path :class="{'hidden': open, 'inline-flex': ! open }" class="inline-flex" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M4 6h16M4 12h16M4 18h16" />
                        <path :class="{'hidden': ! open, 'inline-flex': open }" class="hidden" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M6 18L18 6M6 6l12 12" />
                    </svg>
                </button>
            </div>
        </div>
    </div>

    <!-- Responsive Navigation Menu -->
    <div :class="{'block': open, 'hidden': ! open}" class="hidden sm:hidden">
        <div class="pt-2 pb-3 space-y-1">
            <x-responsive-nav-link :href="route('dashboard')" :active="request()->routeIs('dashboard')">
                {{ __('Dashboard') }}
            </x-responsive-nav-link>
        </div>

        <!-- Responsive Settings Options -->
        <div class="pt-4 pb-1 border-t border-gray-200">
            <div class="px-4">
                <div class="font-medium text-base text-gray-800">{{ Auth::user()->name }}</div>
                <div class="font-medium text-sm text-gray-500">{{ Auth::user()->email }}</div>
            </div>

            <div class="mt-3 space-y-1">
                <!-- Authentication -->
                <form method="POST" action="{{ route('logout') }}">
                    @csrf

                    <x-responsive-nav-link :href="route('logout')"
                            onclick="event.preventDefault();
                                        this.closest('form').submit();">
                        {{ __('Log Out') }}
                    </x-responsive-nav-link>
                </form>
            </div>
        </div>
    </div>
</nav>